/*
 * $Date: 1994/09/20 09:24:12 $
 * $Source: /usr/paul/utils/teco/RCS/teco.h,v $
 * $Revision: 4.69 $
 * $Locker:  $
 */

/* teco.h
 * Global TECO Definitions
 * %W% (PC) %G%
 *
 *                     COPYRIGHT (c) 1985-1994 BY
 *		     PAUL CANTRELL & J. M. NISHINAGA
 *                         SUDBURY, MA 01776
 *                        ALL RIGHTS RESERVED
 *
 * This software is furnished in it's current state free of  charge.
 * The   authors   reserve  all  rights  to  the  software.  Further
 * distribution of the software is not authorized. Modifications  to
 * the  software  may  be made locally, but shall not be distributed
 * without the consent of the authors. This software  or  any  other
 * copies  thereof,  may not be provided or otherwise made available
 * to anyone without express permission of the authors. Title to and
 * ownership of this software remains with the authors.
 * 
 */

#define YES 1
#define NO  0
#define FAIL 0
#define SUCCESS 1
#define NULL 0

#define BLOCKED 2

#define VMAJOR 4
#define VMINOR 64

#define TECO_FILENAME_TOTAL_LENGTH 1024
#define TECO_FILENAME_COMPONENT_LENGTH 32
#define TECO_READONLY_NAME "visit"
#define TECO_INTERNAL_BUFFER_NAME "TECO-"
#define TERMCAP_BUFFER_SIZE 2048
#define SCREEN_OUTPUT_BUFFER_SIZE 4096
#define SCREEN_RESERVED_LINES 2
#define SCREEN_MAX_LABEL_FIELDS 4
#define SCREEN_NOMINAL_LINE_WIDTH 132
#define SCREEN_MAX_LINES 1024
#define SCREEN_MINIMUM_WINDOW_HEIGHT 4
#define IO_BUFFER_SIZE 512
#define LINE_BUFFER_SIZE 1024
#define DEFAULT_CHECKPOINT (5*60)
#define TAG_HASH_ENTRIES	1024
#define PARSER_STRING_MAX	1024
#define	SEARCH_STRING_MAX	PARSER_STRING_MAX

#define INITIAL_LINE_BUFFER_SIZE 32
#define INCREMENTAL_LINE_BUFFER_SIZE 32
#define MINIMUM_ALLOCATION_BLOCK 32
#define LOOKASIDE_COUNT 32
#define LARGEST_LOOKASIDE_BLOCK (LOOKASIDE_COUNT * MINIMUM_ALLOCATION_BLOCK)
#define BIG_MALLOC_HUNK_SIZE (LARGEST_LOOKASIDE_BLOCK * 64)

/*
 * The following is where the different machines are described so that
 * conditional compilation based on different machines quirks can be done.
 */
#ifdef SEQUOIA
#define SYS_V_UNIX
#define JOB_CONTROL
#define LONG_FILENAMES
#define SUN_STYLE_WINDOW_SIZING
#define TERMINFO
#endif

#ifdef HPUX
#define HAS_FIONREAD
#define SYS_V_UNIX
#define JOB_CONTROL
#define LONG_FILENAMES
#define SUN_STYLE_WINDOW_SIZING
#define TERMINFO
#endif

#ifdef ULTRIX
#define SYS_V_UNIX
#define HAS_FIONREAD
#define JOB_CONTROL
#define LONG_FILENAMES
#define TERMCAP
#define SUN_STYLE_WINDOW_SIZING
#endif

#ifdef OSF
#define SYS_V_UNIX
#define HAS_FIONREAD
#define JOB_CONTROL
#define LONG_FILENAMES
#define TERMCAP
#define SUN_STYLE_WINDOW_SIZING
#endif

#ifdef ALLIANT
#define HAS_FIONREAD
#define BSD_UNIX
#define JOB_CONTROL
#define LONG_FILENAMES
#define SUN_STYLE_WINDOW_SIZING
#define TERMCAP
#define CHECKPOINT
#endif

#ifdef SUN
#define HAS_FIONREAD
#define BSD_UNIX
#define JOB_CONTROL
#define LONG_FILENAMES
#define SUN_STYLE_WINDOW_SIZING
#define TERMCAP
#define CHECKPOINT
#endif

#ifdef __FreeBSD__
#define HAS_FIONREAD
#define BSD_UNIX
#define JOB_CONTROL
#define LONG_FILENAMES
#define SUN_STYLE_WINDOW_SIZING
#define TERMCAP
#define CHECKPOINT
#define TERMIOS
#endif

#ifdef SUNV
#define HAS_FIONREAD
#define SYS_V_UNIX
#define JOB_CONTROL
#define LONG_FILENAMES
#define SUN_STYLE_WINDOW_SIZING
#define TERMINFO
#define CHECKPOINT
#endif

#ifdef SOLARIS2
#define SYS_V_UNIX
#define JOB_CONTROL
#define LONG_FILENAMES
#define SUN_STYLE_WINDOW_SIZING
#define TERMINFO
#define CHECKPOINT
#define bzero(s,n) memset((s),0,(n))
#endif

#ifdef INTEGRATED_SOLUTIONS
#define HAS_FIONREAD
#define BSD_UNIX
#define JOB_CONTROL
#define LONG_FILENAMES
#define TERMCAP
#define CHECKPOINT
#endif

#ifdef INTEL_STAR860
#define HAS_FIONREAD
#define SYS_V_UNIX
#define TERMINFO
#define CHECKPOINT
#endif

#ifdef MACH_i386
#define HAS_FIONREAD
#define BSD_UNIX
#define JOB_CONTROL
#define LONG_FILENAMES
#define SUN_STYLE_WINDOW_SIZING
#define TERMCAP
#define CHECKPOINT
#endif

#ifdef LOCUS_SYSV
#define HAS_FIONREAD
#define SYS_V_UNIX
#define JOB_CONTROL
#define LONG_FILENAMES
#define SUN_STYLE_WINDOW_SIZING
#define TERMINFO
#define CHECKPOINT
#endif

#ifdef SCO_386
#define SYS_V_UNIX
#define TERMCAP
#define CHECKPOINT
#endif

#ifdef STARDENT
#define HAS_FIONREAD
#define SYS_V_UNIX
#define JOB_CONTROL
#define LONG_FILENAMES
#define SUN_STYLE_WINDOW_SIZING
#define TERMINFO
#define CHECKPOINT
#endif

#ifdef AIX
#define HAS_FIONREAD
#define SYS_V_UNIX
#define JOB_CONTROL
#define LONG_FILENAMES
#define SUN_STYLE_WINDOW_SIZING
#define TERMINFO
#define CHECKPOINT
#endif

#ifdef STARDENT_860
#define HAS_FIONREAD
#define INTEL
#define SYS_V_UNIX
#define JOB_CONTROL
#define LONG_FILENAMES
#define SUN_STYLE_WINDOW_SIZING
#define TERMINFO
#define CHECKPOINT
#endif

#ifdef MASSCOMP
#define HAS_FIONREAD
#define SYS_III_UNIX
#define JOB_CONTROL
#define TERMCAP
#define CHECKPOINT
#endif

#ifdef LINUX
#define HAS_FIONREAD
#define SYS_V_UNIX
#define JOB_CONTROL
#define LONG_FILENAMES
#define SUN_STYLE_WINDOW_SIZING
#define TERMCAP
#define CHECKPOINT
#endif

#ifdef AUX
#define JOB_CONTROL
#define SYS_V_UNIX
#define TERMCAP
#define SUN_STYLE_WINDOW_SIZING
#define LONG_FILENAMES
#endif

#ifdef _POSIX_SOURCE
#ifndef TERMCAP
#define TERMINFO
#endif
#endif

#ifdef unix
#define UNIX
#endif

#ifdef vms
#define VMS
#define TERMCAP
#define CHECKPOINT
#endif

/*
 * Unless defined otherwise, we assume 32 bits to an integer and 8 bits / char
 */
#ifndef BITS_PER_INT
#define BITS_PER_INT 32
#endif
#ifndef BITS_PER_CHAR
#define BITS_PER_CHAR 8
#endif

#define ESCAPE 27
#define RUBOUT 127

#define CNTRL_A 1
#define CNTRL_D	4
#define CNTRL_E 5
#define CNTRL_G 7
#define CNTRL_N 14
#define CNTRL_R 18
#define CNTRL_U 21
#define CNTRL_V 22
#define CNTRL_W 23
#define CNTRL_X 24
#define CNTRL_Z 26
#define BELL 7

/*
 * Define memory allocation block types
 */
#define TYPE_C_MINTYPE		33
#define TYPE_C_CBUFF		33
#define TYPE_C_CPERM		34
#define TYPE_C_CMD		35
#define TYPE_C_UNDO		36
#define TYPE_C_SCR		37
#define TYPE_C_SCRBUF		38
#define TYPE_C_SCREEN		39
#define TYPE_C_SCREENBUF	40
#define TYPE_C_LINE		41
#define TYPE_C_LINEBUF		42
#define TYPE_C_BHDR		43
#define TYPE_C_WINDOW		44
#define TYPE_C_LABELFIELD	45
#define TYPE_C_WILD		46
#define TYPE_C_TAGS		47
#define TYPE_C_TAGENT		48
#define TYPE_C_TAGSTR		49
#define TYPE_C_MAXTYPE		49

#define MAGIC_SCREEN		0x01010101
#define MAGIC_BUFFER		0x02020202
#define MAGIC_LINE		0x03030303
#define MAGIC_LINE_LOOKASIDE	0x04040404
#define MAGIC_FORMAT		0x05050505
#define MAGIC_FORMAT_LOOKASIDE	0x06060606

#ifdef DEBUG1
#define PREAMBLE() 		\
    do_preamble_checks();

#define RETURN			\
    do_return_checks();		\
    return;

#define RETURN_VAL(val)		\
    do_return_checks();		\
    return(val);
#else
#define PREAMBLE()
#define RETURN
#define RETURN_VAL()
#endif /* DEBUG1 */


#define ELEMENTS(xyzzy) (sizeof(xyzzy)/sizeof(xyzzy[0]))

/*
 * Define structures used throughout TECO
 */
    struct position_cache {
	struct buff_line *lbp;
	int	base;
    };

#define BUFF_CACHE_CONTENTS(pos_cache) \
    (pos_cache)->lbp->buffer[(pos_cache)->base]
#define BUFF_INCREMENT_CACHE_POSITION(pos_cache) \
    if(++((pos_cache)->base) >= (pos_cache)->lbp->byte_count){ \
	(pos_cache)->lbp = (pos_cache)->lbp->next_line; (pos_cache)->base = 0; \
    }
#define BUFF_DECREMENT_CACHE_POSITION(pos_cache) \
    { \
	if((pos_cache)->base == 0){ \
	    (pos_cache)->lbp = (pos_cache)->lbp->prev_line; \
	    (pos_cache)->base = (pos_cache)->lbp->byte_count; \
	} \
	(pos_cache)->base -= 1; \
    }

    struct buff_header {
	int	buf_magic;
	char	*name;
	int	buffer_number;
	struct	buff_header	*next_header;
	char	ismodified;
	char	isreadonly;
	char	isbackedup;
	int	dot;
	int	zee;
	int	ivalue;
	struct	position_cache	pos_cache;

	struct	buff_line	*first_line;
    };

    struct buff_line {
	int	lin_magic;
	int	buffer_size;
	int	byte_count;
	char	*buffer;
	struct	buff_line	*next_line;
	struct	buff_line	*prev_line;
	struct	format_line	*format_line;
    };

    struct format_line {
	int	fmt_magic;
	struct	buff_header	*fmt_owning_buffer;
	struct	buff_line	*fmt_buffer_line;
	int	fmt_buffer_size;
	short	*fmt_buffer;
	int	fmt_sequence;
	struct	format_line	*fmt_next_line;
	struct	format_line	*fmt_prev_line;
	struct	format_line	*fmt_next_alloc;
	struct	format_line	*fmt_prev_alloc;
	struct	format_line	*fmt_next_window;
	struct	format_line	*fmt_prev_window;
	char	fmt_in_use;
	char	fmt_permanent;
	struct	screen_line	*fmt_saved_line;
	short	fmt_visible_line_position;
	struct	window		*fmt_window_ptr;
    };

    struct screen_line {
	int	scr_magic;
	short	*buffer;
	struct	format_line	*companion;
	int	sequence;
    };

    struct window {
	struct	window		*win_next_window;
	int	win_window_number;
	int	win_x_size;
	int	win_y_size;
	int	win_y_base;
	int	win_y_end;
	struct	buff_header	*win_buffer;
	struct	format_line	win_label_line;
	struct	format_line	*win_dot_format_line;
	int	win_dot_screen_offset;
	char	*win_label_field_contents[SCREEN_MAX_LABEL_FIELDS];
    };

    struct search_element {
	unsigned char type;
	unsigned char value;
	union	{
		int	intarray[256/BITS_PER_INT];
		char	bytearray[256/BITS_PER_CHAR];
	}bitmask;
	union	{
		int	intarray[256/BITS_PER_INT];
		char	bytearray[256/BITS_PER_CHAR];
	}repmask;
    };

    struct search_buff {
	int	length;
	char	input[PARSER_STRING_MAX];
	struct	search_element	data[PARSER_STRING_MAX];
	char	error_message_given;
    };

    struct wildcard_expansion {
	struct	wildcard_expansion	*we_next;
	char	we_name[TECO_FILENAME_TOTAL_LENGTH-4];
    };

    struct tagent {
	char	*te_symbol;
	char	*te_filename;
	char	*te_lineno;
	char	*te_search_string;
	struct	tagent	*te_next;
    };

    struct tags {
	struct tagent	*current_entry;
	struct	tagent	*tagents[TAG_HASH_ENTRIES];
    };
	
/*
 * Define the various flags in a screen display short int
 */
#define SCREEN_M_DATA		0x00FF
#define SCREEN_M_FLAGS		0xFF00
#define SCREEN_M_REVERSE	0x0100

/*
 * Define constants for the label line fields
 */
#define LABEL_C_TECONAME	0
#define LABEL_C_FILENAME	1
#define LABEL_C_READONLY	2
#define LABEL_C_MODIFIED	3

/*
 * Define constants for EJ command
 */
#define SETOPTION_MIN_OPTION 1

#define SETOPTION_ALTERNATE_ESCAPE_CHAR 1
#define SETOPTION_SCREEN_HEIGHT 2
#define SETOPTION_SCREEN_WIDTH 3
#define SETOPTION_ALTERNATE_DELETE_CHAR 4
#define SETOPTION_FORCE_8_BIT_CHARS 5

#define SETOPTION_MAX_OPTION 5

/*
 * Define constants for FT command
 */
#define TAGS_MIN_OPTION 0

#define TAGS_LOAD_TAGS_FILE		0
#define TAGS_SEARCH_TAGS_FILE		1
#define TAGS_TEST_FOR_LOADED_TAGS	2
#define TAGS_INSERT_TARGET_FILE		3
#define TAGS_INSERT_SEARCH_STRING	4
#define TAGS_INSERT_LINENO		5
#define TAGS_INSERT_ALL			6

#define TAGS_MAX_OPTION 6

/*
 * Define useful macros
 */
#define UPCASE(char) (islower(char) ? TOUPPER(char) : char)
#ifdef SYS_III_UNIX
#define TOUPPER(char) _toupper(char)
#define TOLOWER(char) _tolower(char)
#else
#define TOUPPER(char) toupper(char)
#define TOLOWER(char) tolower(char)
#endif

/*
 * Include Files for generic UNIX systems
 */
#ifdef UNIX
#include <ctype.h>
#include <stdio.h>
#include <errno.h>
#include <signal.h>
#include <pwd.h>
#include <sys/param.h>
#ifndef SEQUOIA
#include <sys/ioctl.h>
#endif /* SEQUOIA */
#include <sys/types.h>
#include <sys/stat.h>
#endif

/*
 * Include files for POSIX
 */
#ifdef _POSIX_SOURCE
#define TERMIOS
#ifdef SYS_V_UNIX
#define ATT_UNIX
#endif
#include <fcntl.h>
#include <termios.h>
#include <dirent.h>
#define has_tcsetattr 1
#define has_tcgetattr 1
#ifdef AUX
#undef has_tcsetattr
#undef has_tcgetattr
#define has_tcsetattr 0
#define has_tcgetattr 0
#endif
#else /* NON-POSIX */

/*
 * Include Files for UNIX System III (MASSCOMP)
 */
#ifdef SYS_III_UNIX
#define ATT_UNIX
#include <fcntl.h>
#include <pagsiz.h>
#include <termio.h>
#endif

/*
 * Include Files for UNIX System V (INTEL+STARDENT)
 */
#ifdef SYS_V_UNIX
#define ATT_UNIX
#ifdef LOCUS_SYSV
#include <sys/filio.h>
#endif /* LOCUS_SYSV */
#include <fcntl.h>
#include <termio.h>
#include <dirent.h>
#endif

/*
 * Include Files for Berkely UNIX System 4.3 (Alliant, Sun, etc.)
 */
#ifdef  BSD_UNIX
#include <sys/dir.h>
#include <sys/file.h>
#ifdef TERMIOS
#include <termios.h>
#else
#include <sgtty.h>
#include <sys/ttydev.h>
#include <sys/ioctl.h>
#endif
#endif

#endif /* !POSIX */

/*
 * Digital Equpment VMS Operating System
 */
#ifdef VMS
#include "tecvms.h"
#endif

#ifdef LOCUS_MACH_i386
#define CAUSE_BUS_ERROR() 					\
		{						\
		    restore_tty();				\
		    *((int *)(0xEEEEEEEE))			\
			= *((int *)(0xEEEEEEEE));		\
		}
#endif
#ifdef HPUX
#define CAUSE_BUS_ERROR()					\
		{						\
		    raise(SIGINT);				\
		}
#endif

#ifndef CAUSE_BUS_ERROR
#define CAUSE_BUS_ERROR() 					\
		{						\
		    int fake_destination;			\
		    fake_destination = *((int *)(0x0FFFFFFF));	\
		}
#endif
